package com.hys.app.service.erp;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hys.app.framework.database.WebPage;
import com.hys.app.framework.database.mybatisplus.base.BaseService;
import com.hys.app.model.erp.dos.GoodsDO;
import com.hys.app.model.erp.dos.GoodsSnDO;
import com.hys.app.model.erp.dos.ProductDO;
import com.hys.app.model.erp.dto.*;
import com.hys.app.model.erp.vo.GoodsSnVO;
import com.hys.app.model.erp.vo.GoodsVO;
import com.hys.app.model.erp.vo.ProductVO;

import java.util.List;

/**
 * 商品业务层接口
 *
 * @author 张崧
 * 2023-12-26 15:56:58
 */
public interface GoodsSnManager extends BaseService<GoodsSnDO> {
    WebPage<GoodsSnVO> list(GoodsSnQueryParams queryParams);


    WebPage<GoodsSnVO> searchCount(GoodsSnQueryParams queryParams);

    void add(GoodsSnDTO goodsSnDTO);

    void edit(GoodsSnDTO goodsSnDTO);

    void createMore(GoodsSnCreateDTO request);

    GoodsSnVO getDetail(Long id);

    void delete(Long id);


    /**
     * 获取所有有序列号的sku
     *
     * @param queryParams
     * @return
     */
    Page<ProductVO> getSnProduct(GoodsSnQueryParams queryParams);

    /**
     * 根据商品生成序列号
     *
     * @param goodsDTO
     */
    void createSnCode(GoodsSnDTO goodsDTO);

    /**
     * 单挑修改序列号
     *
     * @param id
     * @param snCode
     */
    void updateSnCode(Long id, String snCode);
}

